package de.mdelab.mlsdm.interpreter.facade;

import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityEdgeGuardEnum;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.sdm.interpreter.core.facade.IActivityEdgeFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMActivityEdgeFacade implements IActivityEdgeFacade<ActivityNode, ActivityEdge>
{

	@Override
	public ActivityNode getSource(final ActivityEdge activityEdge)
	{
		assert activityEdge != null;
		assert activityEdge.getSource() != null;

		return activityEdge.getSource();
	}

	@Override
	public ActivityNode getTarget(final ActivityEdge activityEdge)
	{
		assert activityEdge != null;
		assert activityEdge.getTarget() != null;

		if (activityEdge.getTarget().eClass() == MlsdmPackage.Literals.STRUCTURED_NODE)
		{
			for (final ActivityNode node : ((StructuredNode) activityEdge.getTarget()).getNodes())
			{
				if (node.eClass() == MlsdmPackage.Literals.INITIAL_NODE)
				{
					return node;
				}
			}
		}
		else if (activityEdge.getTarget().eClass() == MlsdmPackage.Literals.FLOW_FINAL_NODE)
		{
			assert activityEdge.getTarget().getActivityNodeContainer() instanceof StructuredNode;

			assert ((StructuredNode) activityEdge.getTarget().getActivityNodeContainer()).getIncomingEdges().size() == 1;
			assert ((StructuredNode) activityEdge.getTarget().getActivityNodeContainer()).getIncomingEdges().get(0).getGuardType() == ActivityEdgeGuardEnum.FOR_EACH;

			return ((StructuredNode) activityEdge.getTarget().getActivityNodeContainer()).getIncomingEdges().get(0).getSource();
		}

		return activityEdge.getTarget();
	}

}
