package de.mdelab.mlsdm.interpreter.facade;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.facade.IActivityEdgeFacade;
import de.mdelab.sdm.interpreter.core.facade.IActivityFacade;
import de.mdelab.sdm.interpreter.core.facade.IClassifierFacade;
import de.mdelab.sdm.interpreter.core.facade.IDecisionNodeFacade;
import de.mdelab.sdm.interpreter.core.facade.IExpressionFacade;
import de.mdelab.sdm.interpreter.core.facade.IExpressionNodeFacade;
import de.mdelab.sdm.interpreter.core.facade.IFeatureFacade;
import de.mdelab.sdm.interpreter.core.facade.IFinalNodeFacade;
import de.mdelab.sdm.interpreter.core.facade.IInstanceFacade;
import de.mdelab.sdm.interpreter.core.facade.IStoryNodeFacade;
import de.mdelab.sdm.interpreter.core.facade.IStoryPatternFacade;
import de.mdelab.sdm.interpreter.core.facade.IStoryPatternLinkFacade;
import de.mdelab.sdm.interpreter.core.facade.IStoryPatternObjectFacade;
import de.mdelab.sdm.interpreter.core.facade.IUnspecificActivityNodeFacade;
import de.mdelab.sdm.interpreter.core.facade.MetamodelFacadeFactory;

public class MLSDMMetamodelFacadeFactory
		extends
		MetamodelFacadeFactory<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>
{
	public static MLSDMMetamodelFacadeFactory	INSTANCE	= new MLSDMMetamodelFacadeFactory();

	protected MLSDMMetamodelFacadeFactory()
	{
		super();
	}

	@Override
	protected IClassifierFacade<EClassifier> createClassifierFacade()
	{
		return new MLSDMClassifierFacade();
	}

	@Override
	protected IFeatureFacade<EStructuralFeature> createFeatureFacade()
	{
		return new MLSDMFeatureFacade();
	}

	@Override
	protected IStoryPatternObjectFacade<AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> createStoryPatternObjectFacade()
	{
		return new MLSDMStoryPatternObjectFacade();
	}

	@Override
	protected IStoryPatternLinkFacade<AbstractStoryPatternObject, AbstractStoryPatternLink, EStructuralFeature> createStoryPatternLinkFacade()
	{
		return new MLSDMStoryPatternLinkFacade();
	}

	@Override
	protected IStoryPatternFacade<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, MLExpression> createStoryPatternFacade()
	{
		return new MLSDMStoryPatternFacade();
	}

	@Override
	protected IInstanceFacade<AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> createInstanceFacade()
	{
		return new MLSDMInstanceFacade();
	}

	@Override
	protected IExpressionFacade<MLExpression> createExpressionFacade()
	{
		return new MLSDMExpressionFacade();
	}

	@Override
	protected IActivityFacade<Activity, ActivityNode> createActivityFacade()
	{
		return new MLSDMActivityFacade();
	}

	@Override
	protected IUnspecificActivityNodeFacade<ActivityNode, ActivityEdge> createUnspecificActivityNodeFacade()
	{
		return new MLSDMUnspecificActivityNodeFacade();
	}

	@Override
	protected IStoryNodeFacade<ActivityNode, ActivityEdge, StoryPattern> createStoryNodeFacade()
	{
		return new MLSDMStoryNodeFacade();
	}

	@Override
	protected IExpressionNodeFacade<ActivityNode, ActivityEdge, MLExpression> createExpressionNodeFacade()
	{
		return new MLSDMExpressionNodeFacade();
	}

	@Override
	protected IDecisionNodeFacade<ActivityNode, ActivityEdge, MLExpression> createDecisionNodeFacade()
	{
		return new MLSDMDecisionNodeFacade();
	}

	@Override
	protected IFinalNodeFacade<ActivityNode, MLExpression> createFinalNodeFacade()
	{
		return new MLSDMActivityFinalNodeFacade();
	}

	@Override
	protected IActivityEdgeFacade<ActivityNode, ActivityEdge> createActivityEdgeFacade()
	{
		return new MLSDMActivityEdgeFacade();
	}
}
