package de.mdelab.mlsdm.interpreter.facade;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.sdm.interpreter.core.facade.IStoryPatternLinkFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMStoryPatternLinkFacade implements
		IStoryPatternLinkFacade<AbstractStoryPatternObject, AbstractStoryPatternLink, EStructuralFeature>
{
	@Override
	public String getName(final AbstractStoryPatternLink spl)
	{
		final EClass splEClass = spl.eClass();

		if (splEClass == MlstorypatternsPackage.Literals.STORY_PATTERN_LINK)
		{
			assert ((StoryPatternLink) spl).getFeature() != null;

			return ((StoryPatternLink) spl).getFeature().getName();
		}
		else if (splEClass == MlstorypatternsPackage.Literals.CONTAINMENT_LINK)
		{
			return "[containment]";
		}
		else if (splEClass == MlstorypatternsPackage.Literals.EXPRESSION_LINK)
		{
			return ((ExpressionLink) spl).getExpression().toString();
		}
		else if (splEClass == MlstorypatternsPackage.Literals.MAP_ENTRY_LINK)
		{
			assert ((MapEntryLink) spl).getFeature() != null;

			return ((MapEntryLink) spl).getFeature().getName();
		}
		else
		{
			throw new UnsupportedOperationException();
		}
	}
}
